"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getObjectDetails = exports.getContactInformation = exports.getLedgers = exports.getTransactions = exports.getAccountById = exports.getAccountList = exports.getLoanToValue = exports.getInterestRates = exports.updateContactInformation = exports.createAccount = exports.uploadDocumentToReservedAccount = exports.reserveAccount = void 0;
const axios_1 = __importDefault(require("axios"));
__exportStar(require("./schemas"), exports);
/**
 * Reserve account
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function reserveAccount(query, baseUrl = "http://services-core") {
    const response = await axios_1.default.post(`${baseUrl}/api/accounts/reservation`, null, { params: query });
    return response.data;
}
exports.reserveAccount = reserveAccount;
/**
 * Upload document to reserved account
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function uploadDocumentToReservedAccount(accountNo, body, baseUrl = "http://services-core") {
    const response = await axios_1.default.patch(`${baseUrl}/api/accounts/reservation/${accountNo}`, body, {
        maxBodyLength: Infinity,
        maxContentLength: Infinity,
    });
    return response.data;
}
exports.uploadDocumentToReservedAccount = uploadDocumentToReservedAccount;
/**
 * Create account
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function createAccount(data, baseUrl = "http://services-core") {
    const response = await axios_1.default.post(`${baseUrl}/api/accounts`, data);
    return response.data;
}
exports.createAccount = createAccount;
/**
 * Update contact information
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function updateContactInformation(query, data, baseUrl = "http://services-core") {
    const response = await axios_1.default.post(`${baseUrl}/api/contacts`, data, { params: query });
    return response.data;
}
exports.updateContactInformation = updateContactInformation;
/**
 * Get interest rates
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function getInterestRates(query, baseUrl = "http://services-core") {
    const response = await axios_1.default.get(`${baseUrl}/api/information/interest-rates`, { params: query });
    return response.data;
}
exports.getInterestRates = getInterestRates;
/**
 * Get loan to value
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function getLoanToValue(query, baseUrl = "http://services-core") {
    const response = await axios_1.default.get(`${baseUrl}/api/information/loan-to-value`, { params: query });
    return response.data;
}
exports.getLoanToValue = getLoanToValue;
/**
 * Get account list
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function getAccountList(baseUrl = "http://services-core") {
    const response = await axios_1.default.get(`${baseUrl}/api/accounts`);
    return response.data;
}
exports.getAccountList = getAccountList;
/**
 * Create account
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function getAccountById(baseUrl = "http://services-core") {
    const response = await axios_1.default.get(`${baseUrl}/api/accounts/:accountNo/?${process.env.COUNTRY_ID}&${process.env.BUSINESS_AREA_ID}`);
    return response.data;
}
exports.getAccountById = getAccountById;
/**
 * Get transactions
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function getTransactions(query, baseUrl = "http://services-core") {
    const response = await axios_1.default.get(`${baseUrl}/api/accounts/:accountNo/transactions`, { params: query });
    return response.data;
}
exports.getTransactions = getTransactions;
/**
 * Fetch Ledgers/Invoices
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function getLedgers(query, baseUrl = "http://services-core") {
    const response = await axios_1.default.get(`${baseUrl}/api/accounts/:accountNo/ledgers`, { params: query });
    return response.data;
}
exports.getLedgers = getLedgers;
/**
 * Create account
 * @param baseUrl - Baseurl to service url @defaults to http://services-core
 */
async function getContactInformation(query, baseUrl = "http://services-core") {
    const response = await axios_1.default.get(`${baseUrl}/api/contacts/legal-id/NO17059896083`, { params: query });
    return response.data;
}
exports.getContactInformation = getContactInformation;
async function getObjectDetails(query, baseUrl = "http://services-core") {
    const { data } = await axios_1.default.get(`${baseUrl}/api/information/object-details`, { params: query });
    return data;
}
exports.getObjectDetails = getObjectDetails;
